package java_sound;
import javax.sound.midi.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;


public class MidiAufnehmen extends Frame implements KeyListener{
    
    static MidiAufnehmen midi1;
    Sequencer seq;
    Receiver rcvr;
    Synthesizer synth;
    MidiChannel[] channels;
    int instrument;
    Instrument[] inst;
    Soundbank sb;
    
    
    ShortMessage meineMessage=new ShortMessage();
    Sequence meineSequence;
    Track meinTrack;
    
    File file;
    long startTime;
    
    static int tonhoehe = 0;
    
    
    public MidiAufnehmen(){
        super("Midi Aufnehmen");
        addKeyListener(this);
        setBackground(Color.red);
        setSize(400,100);
        setLocation(200,100);
        setVisible(true);
        
        
        
        
        System.out.println("Druecke ESC um die Aufnahme zu beenden und das Midi File abzuspeichern!");
        System.out.println("jetzt bitte spielen");
        // Hier alles fr die Aufnahme bereit machen
        
        try{
            
            
            //Sequencer holen
            seq = 
            
            //Synthesizer holen
            synth = 
            
            
            //Sequenzer ffnen
            
            
            //Synth. ffnen
            
            
            //Kanle vom Synth. holen
            channels = 
            
            //Soundbank vom Synth. holen
            sb = 
            
            //Instrumente aus Soundbank holen
            inst = 
            
            //Instrument auf Gittare (105) setzen
            instrument = 105;
            
            
            
        }catch (MidiUnavailableException e){
            e.printStackTrace();
            System.exit(0);
        }
        
        try{
            //neue Sequenz erzeugen mit einer Auflsung von 8 Ticks pro viertel Note
            meineSequence = 
            
            //Neue Spur in Sequenz anlegen und "meinTrack" zuweisen
            meinTrack = 
            
            //Sequenz an Sequencer bergeben
            
            
            
        }catch(InvalidMidiDataException e){System.out.println("Kein gltiges MidiFormat!");System.exit(0);}
        
        //Auf angelegter Spur Aufnahme von Midi-Events von Kanal 0 ermglichen
        
        
        startTime = System.currentTimeMillis();
        
        //Instrument in meinTrack auf 105 setzen
        addMessageToTrack(ShortMessage.PROGRAM_CHANGE, 0, instrument, 0);
        
        //Fr Wiedergabe whrend der Aufnahme Programm 105 fr Kanal 0 einstellen
        
        
    }//Konstruktor ENDE
    
    private void addMessageToTrack(int command, int channel, int data1, int data2) {
        
        //Neue Midi-Short-Message "meineMessage" erzeugen
        meineMessage = 
        try {
            //calculate the current tick
            long currentTime = System.currentTimeMillis()-startTime; //currentTime since start in millis
            float tempo = seq.getTempoInMPQ()/1000f; //tempo in millisec. pro quarter note
            int ticksPerQuarter = meineSequence.getResolution(); //ticks per quarter note
            long numberOfQuarters = currentTime/(long)tempo;
            long tick = numberOfQuarters*(long)ticksPerQuarter; //current tick
            
            //bergebene Nachrichtenparameter fr "meineMessage" setzen
            
            
            //Nachricht zusammen mit aktuellem Zeitstempel der Spur hinzufgen
            
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void keyPressed(KeyEvent event) {
        char key1 = event.getKeyChar();
        
        
        if(key1==KeyEvent.VK_ESCAPE) {
            //Sequencer anhalten, d.h. Aufnahme stoppen
            seq.stop();
            
            file = new File("my.mid");
            try {
                //Aufgezeichnete Sequenz in Datei abspeichern als Midi Typ 0
                
                
            }catch(IOException e){
                e.printStackTrace();
            }
            
            try{
                Thread.sleep(5000);
            } catch(InterruptedException e) {}
            
            
            MidiAbspielen midiabspielen = new MidiAbspielen();
        }
        
        
    }
    
    
    
    
    public void keyTyped(KeyEvent event) {
        char key = event.getKeyChar();
        meineMessage = new ShortMessage();
    
        //calculate the current tick
        long currentTime = System.currentTimeMillis()-startTime; //currentTime since start in millis
        float tempo = seq.getTempoInMPQ()/1000f; //tempo in millisec. pro quarter note
        int ticksPerQuarter = meineSequence.getResolution(); //ticks per quarter note
        long numberOfQuarters = currentTime/(long)tempo;
        long tick = numberOfQuarters*(long)ticksPerQuarter; //current tick
        
        
        //Wenn c gedrckt, Note mit Tonhhe 60 und Velocity 93 aufnehmen und abspielen auf Kanal
        if(key == 'c') {
            addMessageToTrack(ShortMessage.NOTE_ON, 0, tonhoehe+ 60, 93);
            channels[0].noteOn(tonhoehe+60,93);
        }
        //Wenn d gedrckt, Note mit Tonhhe 62 und Velocity 93 aufnehmen und abspielen auf Kanal 0
        if(key== 'd') {
            
            addMessageToTrack(ShortMessage.NOTE_ON,  0, tonhoehe+62, 93);
            
            channels[0].noteOn(tonhoehe+62,93);
            
        }
        //Wenn e gedrckt, Note mit Tonhhe 64 und Velocity 93 aufnehmen und abspielen auf Kanal 0
        if(key== 'e') {
            
            
            
        }
        
        
    }
    
    public void keyReleased(KeyEvent event) {
        char key = event.getKeyChar();
        meineMessage = new ShortMessage();
        
        //calculate the current tick
        long currentTime = System.currentTimeMillis()-startTime; //currentTime since start in millis
        float tempo = seq.getTempoInMPQ()/1000f; //tempo in millisec. pro quarter note
        int ticksPerQuarter = meineSequence.getResolution(); //ticks per quarter note
        long numberOfQuarters = currentTime/(long)tempo;
        long tick = numberOfQuarters*(long)ticksPerQuarter; //current tick
        
        //Wenn c gedrckt, Note mit Tonhhe 60 und Velocity 93 abschalten
        if(key == 'c'){
            addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 60, 93);
            channels[0].noteOff(tonhoehe+60,93);
        }
        //Wenn d gedrckt, Note mit Tonhhe 62 und Velocity 93 abschalten
        if(key == 'd'){
            addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 62, 93);
            channels[0].noteOff(tonhoehe+62,93);
        }
        //Wenn e gedrckt, Note mit Tonhhe 64 und Velocity 93 abschalten
        if(key == 'e'){
        
    }
    
    public static void main(String[] args) {
        midi1 = new MidiAufnehmen();
        
        
    }
    
}

