package java_sound;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.sound.sampled.*;
import javax.swing.border.*;
import javax.swing.event.*;


public class ProgrammFenster extends JFrame implements ActionListener {
    public Container con;
    public JButton start, aufnahme, stop;

    static AufnahmeAbspielen auf;
    static SoundFileAbspielen abs;
    static MikroAufnahme rec;


    public ProgrammFenster() {
        super.setTitle("Java Sound");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        super.setSize(320, 200);


        con = getContentPane();
        con.setLayout(null);
        con.setSize(320, 200);
        con.setBackground(Color.lightGray);

        //Buttons werden hinzugefgt
        start = new JButton("Start");
        start.setVisible(true);
        start.setEnabled(false);
        start.setLayout(null);
        start.setBounds(10, 50, 90, 30);
        start.setBackground(Color.gray);

        stop = new JButton("Stop");
        stop.setVisible(true);
        stop.setEnabled(false);
        stop.setLayout(null);
        stop.setBounds(100, 50, 90, 30);
        stop.setBackground(Color.gray);

        aufnahme = new JButton("Aufnahme");
        aufnahme.setVisible(true);
        aufnahme.setEnabled(true);
        aufnahme.setLayout(null);
        aufnahme.setBounds(190, 50, 110, 30);
        aufnahme.setBackground(Color.gray);


        con.add(start);
        con.add(stop);
        con.add(aufnahme);

        start.addActionListener(this);
        stop.addActionListener(this);
        aufnahme.addActionListener(this);

        setVisible(true);


    }


    public void actionPerformed(ActionEvent event) {
        String cmd = event.getActionCommand();


        if (cmd.equals("Start")) {

            auf.start();
            stop.setEnabled(false);
            aufnahme.setEnabled(false);// run-Methode von AufnahmeAbspielen wird gestartet!!!
        } else if (cmd.equals("Stop")) {
            System.out.println("Aufnahme wird beendet!");
            abs.stop();
            rec.aufnahme = false;
            start.setEnabled(true);
            aufnahme.setEnabled(false);

        } else if (cmd.equals("Aufnahme")) {
            System.out.println("Aufnahme");
            rec.start();
            System.out.println("Wav wird abgespielt...");
            abs.start();
            stop.setEnabled(true);


        }
    }


    public static void main(String[] args) {

        auf = new AufnahmeAbspielen();
        abs = new SoundFileAbspielen();
        rec = new MikroAufnahme();
        
        ProgrammFenster fenster = new ProgrammFenster();


    }
}

